/*
 * Hydrogen
 * Copyright(c) 2002-2003 by Alex >Comix< Cominu [comix@users.sourceforge.net]
 *
 * http://hydrogen.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: PlayerControl.h,v 1.17 2003/06/06 21:02:39 comix Exp $
 *
 */


#ifndef PLAYER_CONTROL_H
#define PLAYER_CONTROL_H

#include "qwidget.h"
#include "qpixmap.h"
#include "qtimer.h"
#include "qlabel.h"
#include "config.h"
#include "qmessagebox.h"
#include "qspinbox.h"
#include "qtooltip.h"

#include <hydrogen/Hydrogen.h>

#include "Button.h"
#include "HydrogenApp.h"
#include "CpuLoadWidget.h"
#include "MidiActivityWidget.h"

using std::cerr;
using std::endl;

class MidiActivityWidget;

/**
 * Player control panel
 */
class PlayerControl : public QWidget
{
	Q_OBJECT
	public:
		/** Constructor */
		PlayerControl(QWidget *parent);

		/** Destructor */
		~PlayerControl();

	public slots:
		void playBtnClicked(Button* ref);
		void stopBtnClicked(Button* ref);
		void updatePlayerControl();
		void songModeBtnClicked(Button* ref);
		void liveModeBtnClicked(Button* ref);
		void bpmChanged();

	private:
		static const uint width = 1500;	// FIXME... ;)
		static const uint height = 30;

		Hydrogen *engine;
		QPixmap background;

		ToggleButton *playBtn;
		ToggleButton *stopBtn;

		ToggleButton *songModeBtn;
		ToggleButton *liveModeBtn;

		QSpinBox *bpmSpinBox;

		CpuLoadWidget *cpuLoadWidget;
		MidiActivityWidget *midiActivityWidget;
};



#endif
