/*
 * Hydrogen
 * Copyright(c) 2002-2003 by Alex >Comix< Cominu [comix@users.sourceforge.net]
 *
 * http://hydrogen.sourceforge.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: PreferencesDialog.h,v 1.15 2003/06/12 17:08:19 comix Exp $
 *
 */


#ifndef PREFERENCES_DIALOG_H
#define PREFERENCES_DIALOG_H

#include "config.h"

#include "PreferencesDialog_UI.h"

#include <iostream>
using std::cout;
using std::cerr;
using std::endl;

#include "qspinbox.h"
#include "qlineedit.h"
#include "qcombobox.h"
#include "qlabel.h"
#include "qpixmap.h"
#include "qcheckbox.h"
#include "qfontdialog.h"

#include <hydrogen/PreferencesMng.h>
#include <hydrogen/Hydrogen.h>
#include <hydrogen/AlsaMidiDriver.h>


/**
 * Preferences Dialog
 */
class PreferencesDialog : public PreferencesDialog_UI {
	Q_OBJECT
	private:
		/** ??? */
		void languageChange();

		bool needDriverRestart;

		void cancelBtnClicked();
		void okBtnClicked();
		void driverChanged();
		void bufferSizeChanged();
		void sampleRateChanged();

		void updateDriverInfo();
		void useMetronomeCheckboxChanged();
		void selectApplicationFont();
		void selectMixerFont();
		void restartDriverBtnClicked();

	public:
		PreferencesDialog(QWidget* parent);
		~PreferencesDialog();
};

#endif

